﻿#region MIT

// 
// GMare.
// Copyright (C) 2011 Michael Mercado
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//
//

#endregion

using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace GMare.Forms
{
    /// <summary>
    /// Basic warning form.
    /// </summary>
    public partial class WarningForm : Form
    {
        /// <summary>
        /// Gets whether to show this message in the future.
        /// </summary>
        public bool ShowMessage
        {
            get { return cb_ShowMessage.Checked; }
        }

        /// <summary>
        /// Constructs a new message form.
        /// </summary>
        /// <param name="text">Text to show.</param>
        public WarningForm(string text)
        {
            InitializeComponent();

            // Text of message.
            rtb_Text.Text = text;
        }
    }
}
